include(CMakeFindDependencyMacro)

########################################################################################################################
# Include dependencies                                                                                                 #
########################################################################################################################

set(QSCHEMATIC_DEPENDENCY_GPDS_DOWNLOAD OFF)
set(QSCHEMATIC_DEPENDENCY_GPDS_MINIMUM_VERSION 1.8.4)

# Qt
find_dependency(
    Qt6
    COMPONENTS
        Core
        Gui
        Widgets
)

# GPDS
if (NOT QSCHEMATIC_DEPENDENCY_GPDS_DOWNLOAD)
    find_dependency(
        gpds
        ${QSCHEMATIC_DEPENDENCY_GPDS_MINIMUM_VERSION}
        REQUIRED
    )
endif()

# Add the targets file
include("${CMAKE_CURRENT_LIST_DIR}/qschematic-targets.cmake")
